Index: NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/cfgs/SHARED/field_def_nemo-ice.xml
===================================================================
--- NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/cfgs/SHARED/field_def_nemo-ice.xml	(revision 14593)
+++ NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/cfgs/SHARED/field_def_nemo-ice.xml	(revision 14594)
@@ -112,4 +112,6 @@
       <field id="Ce_ice"       long_name="Sublimation coefficient over sea-ice"                     standard_name="evap_coefficient_ice"                     unit=""     />
       <field id="Ch_ice"       long_name="Sensible heat coefficient over sea-ice"                   standard_name="sensible_heat_coefficient_ice"            unit=""     />
+      <!-- debug theta -->
+      <field id="spt_ice"      long_name="surface potential temperature over sea-ice"               standard_name="surface_potential_temperature_ice"        unit="degC" />
 
       <!-- trends -->
Index: NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/cfgs/SHARED/field_def_nemo-oce.xml
===================================================================
--- NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/cfgs/SHARED/field_def_nemo-oce.xml	(revision 14593)
+++ NEMO/branches/2021/ticket2632_r14588_theta_sbcblk/cfgs/SHARED/field_def_nemo-oce.xml	(revision 14594)
@@ -119,7 +119,7 @@
     <field id="volcello"     long_name="Ocean Volume"                   standard_name="ocean_volume"   unit="m3"       grid_ref="grid_T_3D"/>
     <field id="toce"         long_name="temperature"                         standard_name="sea_water_potential_temperature"   unit="degC"     grid_ref="grid_T_3D"/>
-    <field id="toce_e3t"     long_name="temperature (thickness weighted)"                                                      unit="degC"     grid_ref="grid_T_3D" > toce * e3t </field >
+    <field id="toce_e3t"     long_name="temperature (thickness weighted)"                                                      unit="degC"     grid_ref="grid_T_3D" > toce * e3t </field>
     <field id="soce"         long_name="salinity"                            standard_name="sea_water_practical_salinity"      unit="1e-3"     grid_ref="grid_T_3D"/>
-    <field id="soce_e3t"     long_name="salinity    (thickness weighted)"                                                      unit="1e-3"     grid_ref="grid_T_3D" > soce * e3t </field >
+    <field id="soce_e3t"     long_name="salinity    (thickness weighted)"                                                      unit="1e-3"     grid_ref="grid_T_3D" > soce * e3t </field>
 
     <field id="toce_e3t_300"      field_ref="toce_e3t"          unit="degree_C"     grid_ref="grid_T_zoom_300"      detect_missing_value="true" />
@@ -146,5 +146,5 @@
     <field id="sst"          long_name="Bulk sea surface temperature"                       standard_name="bulk_sea_surface_temperature"        unit="degC"     />
     <field id="t_skin"       long_name="Skin temperature aka SSST"                          standard_name="skin_temperature"                    unit="degC"     />
-    <field id="sst2"         long_name="square of sea surface temperature"                  standard_name="square_of_sea_surface_temperature"   unit="degC2"     > sst * sst </field >
+    <field id="sst2"         long_name="square of sea surface temperature"                  standard_name="square_of_sea_surface_temperature"   unit="degC2"     > sst * sst </field>
     <field id="sstmax"       long_name="max of sea surface temperature"   field_ref="sst"   operation="maximum"                                                 />
     <field id="sstmin"       long_name="min of sea surface temperature"   field_ref="sst"   operation="minimum"                                                 />
@@ -158,5 +158,5 @@
 
     <field id="sss"          long_name="sea surface salinity"                               standard_name="sea_surface_salinity"                unit="1e-3"     />
-    <field id="sss2"         long_name="square of sea surface salinity"                                                                         unit="1e-6"      > sss * sss </field >
+    <field id="sss2"         long_name="square of sea surface salinity"                                                                         unit="1e-6"      > sss * sss </field>
     <field id="sssmax"       long_name="max of sea surface salinity"      field_ref="sss"   operation="maximum"                                                 />
     <field id="sssmin"       long_name="min of sea surface salinity"      field_ref="sss"   operation="minimum"                                                 />
@@ -168,10 +168,10 @@
     <!-- Case EOS = TEOS-10 : output potential temperature -->
     <field id="toce_pot"     long_name="Sea Water Potential Temperature"              standard_name="sea_water_potential_temperature"   unit="degC"     grid_ref="grid_T_3D"/>
-    <field id="sst_pot"      long_name="potential sea surface temperature"             standard_name="sea_surface_temperature"             unit="degC"     />
+    <field id="sst_pot"      long_name="potential sea surface temperature"             standard_name="sea_surface_temperature"          unit="degC"     />
     <field id="tosmint_pot"  long_name="vertical integral of potential temperature times density"   standard_name="integral_wrt_depth_of_product_of_density_and_potential_temperature"  unit="(kg m2) degree_C" />
 
     <field id="ht"           long_name="water column height at T point"                     standard_name="water_column_height_T"                      unit="m" />
     <field id="ssh"          long_name="sea surface height"                                 standard_name="sea_surface_height_above_geoid"             unit="m" />
-    <field id="ssh2"         long_name="square of sea surface height"                       standard_name="square_of_sea_surface_height_above_geoid"   unit="m2" > ssh * ssh </field >
+    <field id="ssh2"         long_name="square of sea surface height"                       standard_name="square_of_sea_surface_height_above_geoid"   unit="m2" > ssh * ssh </field>
     <field id="wetdep"       long_name="wet depth"                                          standard_name="wet_depth"                                  unit="m" />
     <field id="sshmax"       long_name="max of sea surface height"        field_ref="ssh"   operation="maximum"                                                 />
@@ -183,5 +183,5 @@
     <field id="heatc"        long_name="Heat content vertically integrated"                 standard_name="integral_of_sea_water_potential_temperature_wrt_depth_expressed_as_heat_content"   unit="J/m2"       />
     <field id="saltc"        long_name="Salt content vertically integrated"                                                                                                                   unit="1e-3*kg/m2" />
-    <field id="saltc2"       long_name="Salt content vertically integrated"                                                                                                                   unit="1e-3*kg/m2" > saltc * saltc </field >
+    <field id="saltc2"       long_name="Salt content vertically integrated"                                                                                                                   unit="1e-3*kg/m2" > saltc * saltc </field>
 
     <!-- EOS -->
@@ -451,8 +451,9 @@
       <field id="ssq"         long_name="Saturation specific humidity of air at z=0"    standard_name="surface_air_saturation_spec_humidity"  unit="kg/kg" />
       <field id="wspd_blk"    long_name="Bulk wind speed at z=zu"                       standard_name="bulk_wind_speed_at_zu"                 unit="m/s"   />
-      <!-- ln_blk + key_si3 -->
-      <field id="Cd_ice"      long_name="Drag coefficient over ice"                     standard_name="drag_coefficient_ice"                 unit=""  />
-      <field id="Ce_ice"      long_name="Evaporaion coefficient over ice"               standard_name="evap_coefficient_ice"                 unit=""  />
-      <field id="Ch_ice"      long_name="Sensible heat coefficient over ice"            standard_name="sensible_heat_coefficient_ice"        unit=""  />
+      <!-- debug theta -->
+      <field id="tabs_zu"     long_name="Absolute air temperature at z=zu"              standard_name="absolute_air_temperature_at_zu"        unit="degC"  />
+      <field id="pres_zu"     long_name="Air pressure at z=zu"                          standard_name="air_pressure_at_zu"                    unit="Pa"    />
+      <field id="slp"         long_name="Sea-surface air pressure"                      standard_name="surface_air_pressure"                  unit="Pa"    />
+      <field id="sspt"        long_name="Sea-surface potential temperature"             standard_name="surface_potential_temperature"         unit="degC"  />
 
       <!-- available key_oasis3 -->