Index: utils/tools/DOMAINcfg/1_namelist_cfg
===================================================================
--- utils/tools/DOMAINcfg/1_namelist_cfg	(revision 14623)
+++ utils/tools/DOMAINcfg/1_namelist_cfg	(revision 14624)
@@ -14,7 +14,9 @@
 &namdom        !   space and time domain (bathymetry, mesh, timestep)
 !-----------------------------------------------------------------------
+   ln_read_cfg = .false.
    nn_bathy = 2
                            !  or compute (2) from external bathymetry
    nn_interp = 1
+   cn_domcfg   = 'ORCA_R2_zps_domcfg_agrif.nc'                
    cn_topo = 'GEBCO_2020.nc'
    cn_bath = 'elevation'
@@ -53,9 +55,10 @@
    cp_cfg = 'dumb'
    jp_cfg      =       2   !  resolution of the configuration
-   jpidta = 83
-   jpjdta = 62
+   jpidta = 48
+   jpjdta = 50
    jpkdta      =      31   !  number of levels      ( >= jpk )
-   jpiglo = 83
-   jpjglo = 62
+   Ni0glo = 48
+   Nj0glo = 50
+   jpkglo      =      31
    jperio = 0
    ln_use_jattr = .false.  !  use (T) the file attribute: open_ocean_jstart, if present
@@ -96,8 +99,2 @@
 !-----------------------------------------------------------------------
 /
-!-----------------------------------------------------------------------
-&nammpp        !   Massively Parallel Processing                        ("key_mpp_mpi")
-!-----------------------------------------------------------------------
-jpni = 0
-jpnj=0
-/
Index: utils/tools/DOMAINcfg/1_namelist_ref
===================================================================
--- utils/tools/DOMAINcfg/1_namelist_ref	(revision 14623)
+++ utils/tools/DOMAINcfg/1_namelist_ref	(revision 14624)
@@ -28,6 +28,11 @@
    nn_interp   =    1                          ! type of interpolation (nn_bathy =2)
    cn_domcfg   = ' '       ! Name of the domain_cfg input file
-   cn_topo     =  'bathymetry_ORCA12_V3.3.nc'  ! external topo file (nn_bathy =2)
-   cn_bath     =  'Bathymetry'                 ! topo name in file  (nn_bathy =2)
+   cn_fcoord   =  'coordinates.nc'             ! external coordinates file (jphgr_msh = 0)
+   cn_topo     =  'bathy_meter.nc           '  ! external topo file (nn_bathy =1/2)
+   cn_topolvl  =  'bathy_level.nc           '  ! external topo file (nn_bathy =1)
+   cn_fisfd    =  'isf_draft_meter.nc'         ! external isf draft (nn_bathy =1 and ln_isfcav = .true.)
+   cn_bath     =  'Bathymetry'                 ! topo name in file  (nn_bathy =1/2)
+   cn_bathlvl  =  'Bathy_level'                ! lvl name in file   (nn_bathy =1)
+   cn_visfd    =  'isf_draft'                  ! isf draft variable (nn_bathy =1 and ln_isfcav = .true.)
    cn_lon      =  'nav_lon'                    ! lon  name in file  (nn_bathy =2)
    cn_lat      =  'nav_lat'                    ! lat  name in file  (nn_bathy =2)
@@ -76,9 +81,10 @@
    cp_cfg      =  "orca"   !  name of the configuration
    jp_cfg      =       2   !  resolution of the configuration
-   jpidta      =     182   !  1st lateral dimension ( >= jpi )
-   jpjdta      =     149   !  2nd    "         "    ( >= jpj )
+   jpidta      =     180   !  1st lateral dimension ( >= jpi )
+   jpjdta      =     148   !  2nd    "         "    ( >= jpj )
    jpkdta      =      31   !  number of levels      ( >= jpk )
-   jpiglo      =     182   !  1st dimension of global domain --> i =jpidta
-   jpjglo      =     149   !  2nd    -                  -    --> j  =jpjdta
+   Ni0glo      =     180   !  1st dimension of global domain --> i =jpidta
+   Nj0glo      =     148   !  2nd    -                  -    --> j  =jpjdta
+   jpkglo      =      31
    jperio      =       4   !  lateral cond. type (between 0 and 6)
    ln_use_jattr = .false.  !  use (T) the file attribute: open_ocean_jstart, if present
@@ -175,9 +181,9 @@
 &nammpp        !   Massively Parallel Processing                        ("key_mpp_mpi")
 !-----------------------------------------------------------------------
-   cn_mpi_send =  'I'      !  mpi send/recieve type   ='S', 'B', or 'I' for standard send,
-   !                       !  buffer blocking send or immediate non-blocking sends, resp.
-   nn_buffer   =   0       !  size in bytes of exported buffer ('B' case), 0 no exportation
+   ln_listonly =  .false.  !  do nothing else than listing the best domain decompositions (with land domains suppression)
+   !                       !  if T: the largest number of cores tested is defined by max(mppsize, jpni*jpnj)
    ln_nnogather =  .true.  !  activate code to avoid mpi_allgather use at the northfold
-   jpni        =   1       !  jpni   number of processors following i (set automatically if < 1)
-   jpnj        =   1       !  jpnj   number of processors following j (set automatically if < 1)
+   jpni        =   0       !  number of processors following i (set automatically if < 1), see also ln_listonly = T
+   jpnj        =   0       !  number of processors following j (set automatically if < 1), see also ln_listonly = T
+   nn_hls      =   1       !  halo width (applies to both rows and columns)
 /
Index: utils/tools/DOMAINcfg/2_namelist_cfg
===================================================================
--- utils/tools/DOMAINcfg/2_namelist_cfg	(revision 14623)
+++ utils/tools/DOMAINcfg/2_namelist_cfg	(revision 14624)
@@ -14,7 +14,9 @@
 &namdom        !   space and time domain (bathymetry, mesh, timestep)
 !-----------------------------------------------------------------------
+   ln_read_cfg = .false.
    nn_bathy = 2
                            !  or compute (2) from external bathymetry
    nn_interp = 1
+   cn_domcfg   = 'ORCA_R2_zps_domcfg_agrif.nc'                
    cn_topo = 'GEBCO_2020.nc'
    cn_bath = 'elevation'
@@ -53,9 +55,10 @@
    cp_cfg = 'dumb'
    jp_cfg      =       2   !  resolution of the configuration
-   jpidta = 128
+   jpidta = 132
    jpjdta = 140
    jpkdta      =      31   !  number of levels      ( >= jpk )
-   jpiglo = 128
-   jpjglo = 140
+   Ni0glo = 132
+   Nj0glo = 140
+   jpkglo      =      31
    jperio = 0
    ln_use_jattr = .false.  !  use (T) the file attribute: open_ocean_jstart, if present
@@ -96,8 +99,2 @@
 !-----------------------------------------------------------------------
 /
-!-----------------------------------------------------------------------
-&nammpp        !   Massively Parallel Processing                        ("key_mpp_mpi")
-!-----------------------------------------------------------------------
-jpni = 0
-jpnj=0
-/
Index: utils/tools/DOMAINcfg/2_namelist_ref
===================================================================
--- utils/tools/DOMAINcfg/2_namelist_ref	(revision 14623)
+++ utils/tools/DOMAINcfg/2_namelist_ref	(revision 14624)
@@ -28,6 +28,11 @@
    nn_interp   =    1                          ! type of interpolation (nn_bathy =2)
    cn_domcfg   = ' '       ! Name of the domain_cfg input file
-   cn_topo     =  'bathymetry_ORCA12_V3.3.nc'  ! external topo file (nn_bathy =2)
-   cn_bath     =  'Bathymetry'                 ! topo name in file  (nn_bathy =2)
+   cn_fcoord   =  'coordinates.nc'             ! external coordinates file (jphgr_msh = 0)
+   cn_topo     =  'bathy_meter.nc           '  ! external topo file (nn_bathy =1/2)
+   cn_topolvl  =  'bathy_level.nc           '  ! external topo file (nn_bathy =1)
+   cn_fisfd    =  'isf_draft_meter.nc'         ! external isf draft (nn_bathy =1 and ln_isfcav = .true.)
+   cn_bath     =  'Bathymetry'                 ! topo name in file  (nn_bathy =1/2)
+   cn_bathlvl  =  'Bathy_level'                ! lvl name in file   (nn_bathy =1)
+   cn_visfd    =  'isf_draft'                  ! isf draft variable (nn_bathy =1 and ln_isfcav = .true.)
    cn_lon      =  'nav_lon'                    ! lon  name in file  (nn_bathy =2)
    cn_lat      =  'nav_lat'                    ! lat  name in file  (nn_bathy =2)
@@ -76,9 +81,10 @@
    cp_cfg      =  "orca"   !  name of the configuration
    jp_cfg      =       2   !  resolution of the configuration
-   jpidta      =     182   !  1st lateral dimension ( >= jpi )
-   jpjdta      =     149   !  2nd    "         "    ( >= jpj )
+   jpidta      =     180   !  1st lateral dimension ( >= jpi )
+   jpjdta      =     148   !  2nd    "         "    ( >= jpj )
    jpkdta      =      31   !  number of levels      ( >= jpk )
-   jpiglo      =     182   !  1st dimension of global domain --> i =jpidta
-   jpjglo      =     149   !  2nd    -                  -    --> j  =jpjdta
+   Ni0glo      =     180   !  1st dimension of global domain --> i =jpidta
+   Nj0glo      =     148   !  2nd    -                  -    --> j  =jpjdta
+   jpkglo      =      31
    jperio      =       4   !  lateral cond. type (between 0 and 6)
    ln_use_jattr = .false.  !  use (T) the file attribute: open_ocean_jstart, if present
@@ -175,9 +181,9 @@
 &nammpp        !   Massively Parallel Processing                        ("key_mpp_mpi")
 !-----------------------------------------------------------------------
-   cn_mpi_send =  'I'      !  mpi send/recieve type   ='S', 'B', or 'I' for standard send,
-   !                       !  buffer blocking send or immediate non-blocking sends, resp.
-   nn_buffer   =   0       !  size in bytes of exported buffer ('B' case), 0 no exportation
+   ln_listonly =  .false.  !  do nothing else than listing the best domain decompositions (with land domains suppression)
+   !                       !  if T: the largest number of cores tested is defined by max(mppsize, jpni*jpnj)
    ln_nnogather =  .true.  !  activate code to avoid mpi_allgather use at the northfold
-   jpni        =   1       !  jpni   number of processors following i (set automatically if < 1)
-   jpnj        =   1       !  jpnj   number of processors following j (set automatically if < 1)
+   jpni        =   0       !  number of processors following i (set automatically if < 1), see also ln_listonly = T
+   jpnj        =   0       !  number of processors following j (set automatically if < 1), see also ln_listonly = T
+   nn_hls      =   1       !  halo width (applies to both rows and columns)
 /
Index: utils/tools/DOMAINcfg/3_namelist_cfg
===================================================================
--- utils/tools/DOMAINcfg/3_namelist_cfg	(revision 14623)
+++ utils/tools/DOMAINcfg/3_namelist_cfg	(revision 14624)
@@ -14,7 +14,9 @@
 &namdom        !   space and time domain (bathymetry, mesh, timestep)
 !-----------------------------------------------------------------------
+   ln_read_cfg = .false.
    nn_bathy = 2
                            !  or compute (2) from external bathymetry
    nn_interp = 1
+   cn_domcfg   = 'ORCA_R2_zps_domcfg_agrif.nc'                
    cn_topo = 'GEBCO_2020.nc'
    cn_bath = 'elevation'
@@ -53,10 +55,11 @@
    cp_cfg = 'dumb'
    jp_cfg      =       2   !  resolution of the configuration
-   jpidta = 542
-   jpjdta = 107
+   jpidta = 134
+   jpjdta = 128
    jpkdta      =      31   !  number of levels      ( >= jpk )
-   jpiglo = 542
-   jpjglo = 107
-   jperio = 1
+   Ni0glo = 134
+   Nj0glo = 128
+   jpkglo      =      31
+   jperio = 0
    ln_use_jattr = .false.  !  use (T) the file attribute: open_ocean_jstart, if present
                            !  in netcdf input files, as the start j-row for reading
@@ -96,8 +99,2 @@
 !-----------------------------------------------------------------------
 /
-!-----------------------------------------------------------------------
-&nammpp        !   Massively Parallel Processing                        ("key_mpp_mpi")
-!-----------------------------------------------------------------------
-jpni = 0
-jpnj=0
-/
Index: utils/tools/DOMAINcfg/3_namelist_ref
===================================================================
--- utils/tools/DOMAINcfg/3_namelist_ref	(revision 14623)
+++ utils/tools/DOMAINcfg/3_namelist_ref	(revision 14624)
@@ -28,6 +28,11 @@
    nn_interp   =    1                          ! type of interpolation (nn_bathy =2)
    cn_domcfg   = ' '       ! Name of the domain_cfg input file
-   cn_topo     =  'bathymetry_ORCA12_V3.3.nc'  ! external topo file (nn_bathy =2)
-   cn_bath     =  'Bathymetry'                 ! topo name in file  (nn_bathy =2)
+   cn_fcoord   =  'coordinates.nc'             ! external coordinates file (jphgr_msh = 0)
+   cn_topo     =  'bathy_meter.nc           '  ! external topo file (nn_bathy =1/2)
+   cn_topolvl  =  'bathy_level.nc           '  ! external topo file (nn_bathy =1)
+   cn_fisfd    =  'isf_draft_meter.nc'         ! external isf draft (nn_bathy =1 and ln_isfcav = .true.)
+   cn_bath     =  'Bathymetry'                 ! topo name in file  (nn_bathy =1/2)
+   cn_bathlvl  =  'Bathy_level'                ! lvl name in file   (nn_bathy =1)
+   cn_visfd    =  'isf_draft'                  ! isf draft variable (nn_bathy =1 and ln_isfcav = .true.)
    cn_lon      =  'nav_lon'                    ! lon  name in file  (nn_bathy =2)
    cn_lat      =  'nav_lat'                    ! lat  name in file  (nn_bathy =2)
@@ -76,9 +81,10 @@
    cp_cfg      =  "orca"   !  name of the configuration
    jp_cfg      =       2   !  resolution of the configuration
-   jpidta      =     182   !  1st lateral dimension ( >= jpi )
-   jpjdta      =     149   !  2nd    "         "    ( >= jpj )
+   jpidta      =     180   !  1st lateral dimension ( >= jpi )
+   jpjdta      =     148   !  2nd    "         "    ( >= jpj )
    jpkdta      =      31   !  number of levels      ( >= jpk )
-   jpiglo      =     182   !  1st dimension of global domain --> i =jpidta
-   jpjglo      =     149   !  2nd    -                  -    --> j  =jpjdta
+   Ni0glo      =     180   !  1st dimension of global domain --> i =jpidta
+   Nj0glo      =     148   !  2nd    -                  -    --> j  =jpjdta
+   jpkglo      =      31
    jperio      =       4   !  lateral cond. type (between 0 and 6)
    ln_use_jattr = .false.  !  use (T) the file attribute: open_ocean_jstart, if present
@@ -175,9 +181,9 @@
 &nammpp        !   Massively Parallel Processing                        ("key_mpp_mpi")
 !-----------------------------------------------------------------------
-   cn_mpi_send =  'I'      !  mpi send/recieve type   ='S', 'B', or 'I' for standard send,
-   !                       !  buffer blocking send or immediate non-blocking sends, resp.
-   nn_buffer   =   0       !  size in bytes of exported buffer ('B' case), 0 no exportation
+   ln_listonly =  .false.  !  do nothing else than listing the best domain decompositions (with land domains suppression)
+   !                       !  if T: the largest number of cores tested is defined by max(mppsize, jpni*jpnj)
    ln_nnogather =  .true.  !  activate code to avoid mpi_allgather use at the northfold
-   jpni        =   1       !  jpni   number of processors following i (set automatically if < 1)
-   jpnj        =   1       !  jpnj   number of processors following j (set automatically if < 1)
+   jpni        =   0       !  number of processors following i (set automatically if < 1), see also ln_listonly = T
+   jpnj        =   0       !  number of processors following j (set automatically if < 1), see also ln_listonly = T
+   nn_hls      =   1       !  halo width (applies to both rows and columns)
 /
Index: utils/tools/DOMAINcfg/namelist_cfg
===================================================================
--- utils/tools/DOMAINcfg/namelist_cfg	(revision 14623)
+++ utils/tools/DOMAINcfg/namelist_cfg	(revision 14624)
@@ -15,7 +15,9 @@
 &namdom        !   space and time domain (bathymetry, mesh, timestep)
 !-----------------------------------------------------------------------
+   ln_read_cfg = .true.
    nn_bathy    =    1      !  compute analyticaly (=0) or read (=1) the bathymetry file
                            !  or compute (2) from external bathymetry
-   nn_interp   =    1                          ! type of interpolation (nn_bathy =2)                       
+   nn_interp   =    1                          ! type of interpolation (nn_bathy =2)
+   cn_domcfg   = 'ORCA_R2_zps_domcfg_agrif.nc'                
    cn_topo     =  'bathymetry_ORCA12_V3.3.nc'  ! external topo file (nn_bathy =2)
    cn_bath     =  'Bathymetry'                 ! topo name in file  (nn_bathy =2)
@@ -54,9 +56,10 @@
    cp_cfg      =  "orca"   !  name of the configuration
    jp_cfg      =       2   !  resolution of the configuration
-   jpidta      =     182   !  1st lateral dimension ( >= jpi )
-   jpjdta      =     149   !  2nd    "         "    ( >= jpj )
+   jpidta      =     180   !  1st lateral dimension ( >= jpi )
+   jpjdta      =     148   !  2nd    "         "    ( >= jpj )
    jpkdta      =      31   !  number of levels      ( >= jpk )
-   jpiglo      =     182   !  1st dimension of global domain --> i =jpidta
-   jpjglo      =     149   !  2nd    -                  -    --> j  =jpjdta
+   Ni0glo      =     180   !  1st dimension of global domain --> i =jpidta
+   Nj0glo      =     148   !  2nd    -                  -    --> j  =jpjdta
+   jpkglo      =      31
    jperio      =       4   !  lateral cond. type (between 0 and 6)
    ln_use_jattr = .false.  !  use (T) the file attribute: open_ocean_jstart, if present
@@ -97,8 +100,2 @@
 !-----------------------------------------------------------------------
 /
-!-----------------------------------------------------------------------
-&nammpp        !   Massively Parallel Processing                        ("key_mpp_mpi")
-!-----------------------------------------------------------------------
-jpni = 0
-jpnj=0
-/
Index: utils/tools/DOMAINcfg/namelist_ref
===================================================================
--- utils/tools/DOMAINcfg/namelist_ref	(revision 14623)
+++ utils/tools/DOMAINcfg/namelist_ref	(revision 14624)
@@ -82,9 +82,10 @@
    cp_cfg      =  "orca"   !  name of the configuration
    jp_cfg      =       2   !  resolution of the configuration
-   jpidta      =     182   !  1st lateral dimension ( >= jpi )
-   jpjdta      =     149   !  2nd    "         "    ( >= jpj )
+   jpidta      =     180   !  1st lateral dimension ( >= jpi )
+   jpjdta      =     148   !  2nd    "         "    ( >= jpj )
    jpkdta      =      31   !  number of levels      ( >= jpk )
-   jpiglo      =     182   !  1st dimension of global domain --> i =jpidta
-   jpjglo      =     149   !  2nd    -                  -    --> j  =jpjdta
+   Ni0glo      =     180   !  1st dimension of global domain --> i =jpidta
+   Nj0glo      =     148   !  2nd    -                  -    --> j  =jpjdta
+   jpkglo      =      31
    jperio      =       4   !  lateral cond. type (between 0 and 6)
    ln_use_jattr = .false.  !  use (T) the file attribute: open_ocean_jstart, if present
@@ -181,9 +182,9 @@
 &nammpp        !   Massively Parallel Processing                        ("key_mpp_mpi")
 !-----------------------------------------------------------------------
-   cn_mpi_send =  'I'      !  mpi send/recieve type   ='S', 'B', or 'I' for standard send,
-   !                       !  buffer blocking send or immediate non-blocking sends, resp.
-   nn_buffer   =   0       !  size in bytes of exported buffer ('B' case), 0 no exportation
+   ln_listonly =  .false.  !  do nothing else than listing the best domain decompositions (with land domains suppression)
+   !                       !  if T: the largest number of cores tested is defined by max(mppsize, jpni*jpnj)
    ln_nnogather =  .true.  !  activate code to avoid mpi_allgather use at the northfold
-   jpni        =   1       !  jpni   number of processors following i (set automatically if < 1)
-   jpnj        =   1       !  jpnj   number of processors following j (set automatically if < 1)
+   jpni        =   0       !  number of processors following i (set automatically if < 1), see also ln_listonly = T
+   jpnj        =   0       !  number of processors following j (set automatically if < 1), see also ln_listonly = T
+   nn_hls      =   1       !  halo width (applies to both rows and columns)
 /